package solution_exercises;

import java.util.Random;

public class Ex4
{
	/*
	 * exercise 4. Write a program, that Creates an array with room for 100
	 * integers, representing the age of persons. Fills the array with random
	 * ages (choose a reasonable interval) Search the array in order to check
	 * whether anyone are 25 years old printout result with the position of the
	 * first appearance. Search the array in order to check the number of
	 * persons who are 25 years old printout the number of appearances. Search
	 * the array in order to find the age of the second youngest. printout the
	 * age of the second youngest person. Traverse the array in order to find
	 * the average age for all persons. printout the average age
	 */
	private int[] ages;

	public Ex4(int count)
	{
		Random generator = new Random();
		ages = new int[count];
		// Fill wit random ages from interval 10..90
		for (int index = 0; index < ages.length; index++)
			ages[index] = generator.nextInt(81) + 10;
	}

	// returns index of first occurence ; -1 if not found
	public int findFirst(int age)
	{
		int index = 0;
		boolean found = false;
		while (!found && index < ages.length)
		{
			found = (age == ages[index++]);
		}
		if (!found)
			index = 0;
		return index-1;
	}

	//return the number of times the value of age occurs in the list ages
	public int countOccurences(int age)
	{
		int count = 0;
		for (int a : ages)
			if (a == age)
				count++;
		return count;
	}

	public int secondYoungest()
	{
		int youngest = Integer.MAX_VALUE;
		int secondYoungest = Integer.MAX_VALUE;
		for (int age : ages)
		{
			if (age < youngest){
				secondYoungest=youngest;
				youngest = age;
			}	
			else if (age < secondYoungest && age > youngest)
				secondYoungest = age;
		}
		return secondYoungest;
	}

	public void prinList()
	{
		for (int index=0;index<ages.length;index++)
		{
			System.out.print(ages[index] + " ");
			
			//add a lineshift for every 20 ages printed
			if ((index+1) % 20 == 0)
				System.out.println();
		}
	}

	public double averageAge()
	{
		double sum = 0;
		for (int age : ages)
			sum += age;
		return sum / ages.length;
	}

	public static void main(String[] args)
	{
		//create and instantiate the list (call constructor)
		Ex4 e = new Ex4(100);
		
		//Print the list
		e.prinList();
		System.out.println();
		
		//get the first occurence of 25
		int hit = e.findFirst(25);
		
		//show result
		System.out.println("Age 25: "
				+ ((hit > -1) ? "found at position " + hit : "NOT found"));
		
		//calculate and display the number of persons with age 25
		System.out.println("Total number of age 25: " + e.countOccurences(25));
		
		//Find and display the age of the secondyoungest
		System.out.println("Second youngest person are " + e.secondYoungest()
				+ " years.");
		
		//Calculate and display the average age
		System.out.println("Avarage age : " + e.averageAge());
	}
}
